//--------------------------------------------------------------------------------------------------
//
// Title       : DP_Syn_RAM36x512
//
//-------------------------------------------------------------------------------------------------
module DP_Syn_RAM36x512
   (   clk,       we,
       wr_addr,   rd_addr,     din,       dout     );
parameter 
    ADDR_WIDTH = 9, 
    DATA_WIDTH = 36;
  
   input    clk,    we;  
   input    [ADDR_WIDTH-1:0] wr_addr, rd_addr;
   input    [DATA_WIDTH-1:0] din;
   output   [DATA_WIDTH-1:0] dout;

   wire logic0,logic1;
   wire [DATA_WIDTH-1:0] logic_bus_0;
   assign logic0 = 0;
   assign logic1 = 1;
   assign logic_bus_0 = 36'b0;

RAMB16_S36_S36   ram_inst
(
.DOA(),           .DOPA(),                 .DOB(dout[35:4]), 
.DOPB(dout[3:0]), .ADDRA(wr_addr),         .CLKA(clk),
.DIA(din[35:4]),  .DIPA(din[3:0]),         .ENA(logic1),  
.SSRA(logic0),    .WEA(we),                .ADDRB(rd_addr), 
.CLKB(clk),       .DIB(logic_bus_0[35:4]), .DIPB(logic_bus_0[3:0]), 
.ENB(logic1),     .SSRB(logic0),           .WEB(logic0)
);
endmodule 
