module channelSums (
	input clk,			// 40MHz
	input clk2x,		// 80MHz, align to negedge of 40MHz
	input frame,		// basically 40MHz from the HTR, in phase with the data
	input [23:0] data,// 1 bit per channel, changes at 80MHz
	output reg [5:0] sum0, sum1, sum2, sum3,
	output [7:0] debug
	);

//

wire[1:0] ch1,ch2,ch3;  // fiber 1
wire[3:0] mch1,mch2,mch3;  // fiber 1
wire[1:0] ch4,ch5,ch6;  // fiber 2
wire[3:0] mch4,mch5,mch6;  // fiber 2
wire[1:0] ch7,ch8,ch9;  // fiber 3
wire[3:0] mch7,mch8,mch9;  // fiber 3
wire[1:0] ch10,ch11,ch12;  // fiber 4
wire[3:0] mch10,mch11,mch12;  // fiber 4
wire[1:0] ch13,ch14,ch15;  // fiber 5
wire[3:0] mch13,mch14,mch15;  // fiber 5
wire[1:0] ch16,ch17,ch18;  // fiber 6
wire[3:0] mch16,mch17,mch18;  // fiber 6
wire[1:0] ch19,ch20,ch21;  // fiber 7
wire[3:0] mch19,mch20,mch21;  // fiber 7
wire[1:0] ch22,ch23,ch24;  // fiber 8
wire[3:0] mch22,mch23,mch24;  // fiber 8
assign debug = {mch1,ch1,ch2};  // for debugging

htrchannel CH1 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[0]),
	.chlevel(ch1), .chdemux(mch1) );
htrchannel CH2 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[1]),
	.chlevel(ch2), .chdemux(mch2) );
htrchannel CH3 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[2]),
	.chlevel(ch3), .chdemux(mch3) );
htrchannel CH4 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[3]),
	.chlevel(ch4), .chdemux(mch4) );
htrchannel CH5 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[4]),
	.chlevel(ch5), .chdemux(mch5) );
htrchannel CH6 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[5]),
	.chlevel(ch6), .chdemux(mch6) );
htrchannel CH7 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[6]),
	.chlevel(ch7), .chdemux(mch7) );
htrchannel CH8 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[7]),
	.chlevel(ch8), .chdemux(mch8) );
htrchannel CH9 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[8]),
	.chlevel(ch9), .chdemux(mch9) );
htrchannel CH10 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[9]),
	.chlevel(ch10), .chdemux(mch10) );
htrchannel CH11 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[10]),
	.chlevel(ch11), .chdemux(mch11) );
htrchannel CH12 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[11]),
	.chlevel(ch12), .chdemux(mch12) );
htrchannel CH13 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[12]),
	.chlevel(ch13), .chdemux(mch13) );
htrchannel CH14 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[13]),
	.chlevel(ch14), .chdemux(mch14) );
htrchannel CH15 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[14]),
	.chlevel(ch15), .chdemux(mch15) );
htrchannel CH16 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[15]),
	.chlevel(ch16), .chdemux(mch16) );
htrchannel CH17 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[16]),
	.chlevel(ch17), .chdemux(mch17) );
htrchannel CH18 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[17]),
	.chlevel(ch18), .chdemux(mch18) );
htrchannel CH19 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[18]),
	.chlevel(ch19), .chdemux(mch19) );
htrchannel CH20 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[19]),
	.chlevel(ch20), .chdemux(mch20) );
htrchannel CH21 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[20]),
	.chlevel(ch21), .chdemux(mch21) );
htrchannel CH22 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[21]),
	.chlevel(ch22), .chdemux(mch22) );
htrchannel CH23 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[22]),
	.chlevel(ch23), .chdemux(mch23) );
htrchannel CH24 (.clk(clk), .clk2x(clk2x), .frame(frame), .chbit(data[23]),
	.chlevel(ch24), .chdemux(mch24) );
//
// for histograms, count the number of channels in each individual threshold
// this number can go from 0 to 48, so we need a number which has 6 bits (0-63)
// (STILL HAVE TO ADD THE BOTTOM!)
// pay attention to the phase of the clock we are using here to latch the sums
//
always @ (negedge clk) begin
  sum0 = mch1[0] + mch2[0] + mch3[0] + mch4[0] + mch5[0] + mch6[0] +
         mch7[0] + mch8[0] + mch9[0] + mch10[0] + mch11[0] + mch12[0] +
         mch13[0] + mch14[0] + mch15[0] + mch16[0] + mch17[0] + mch18[0] +
         mch19[0] + mch20[0] + mch21[0] + mch22[0] + mch23[0] + mch24[0];
  sum1 = mch1[1] + mch2[1] + mch3[1] + mch4[1] + mch5[1] + mch6[1] +
         mch7[1] + mch8[1] + mch9[1] + mch10[1] + mch11[1] + mch12[1] +
         mch13[1] + mch14[1] + mch15[1] + mch16[1] + mch17[1] + mch18[1] +
         mch19[1] + mch20[1] + mch21[1] + mch22[1] + mch23[1] + mch24[1];
  sum2 = mch1[2] + mch2[2] + mch3[2] + mch4[2] + mch5[2] + mch6[2] +
         mch7[2] + mch8[2] + mch9[2] + mch10[2] + mch11[2] + mch12[2] +
         mch13[2] + mch14[2] + mch15[2] + mch16[2] + mch17[2] + mch18[2] +
         mch19[2] + mch20[2] + mch21[2] + mch22[2] + mch23[2] + mch24[2];
  sum3 = mch1[3] + mch2[3] + mch3[3] + mch4[3] + mch5[3] + mch6[3] +
         mch7[3] + mch8[3] + mch9[3] + mch10[3] + mch11[3] + mch12[3] +
         mch13[3] + mch14[3] + mch15[3] + mch16[3] + mch17[3] + mch18[3] +
         mch19[3] + mch20[3] + mch21[3] + mch22[3] + mch23[3] + mch24[3];
  end

endmodule