// This module is the input LUT that perform linearization and muon bit.
// The LUT is implemented using Distributed Ram.
 
`include "define.v"

module lut
  ( DIN, INIT_ADDR, LUT_MODE,LUT_WRITE, INIT_DATA, CLK, DOUT);

 input  LUT_MODE,   LUT_WRITE,  CLK;
 input  [`INPUT_LUT_ADDR_WIDTH - 1 : 0]  DIN, INIT_ADDR;
 input  [`INPUT_LUT_DATA_WIDTH - 1 : 0]  INIT_DATA;
 output [`INPUT_LUT_DATA_WIDTH - 1 : 0]  DOUT; 

 wire  [ `INPUT_LUT_ADDR_WIDTH - 1 : 0]  a = (LUT_MODE) ? INIT_ADDR : DIN;

 //module that infers distributed RAM.         
 spdistram_v InRAM (
    .clk(CLK), 
    .we(LUT_WRITE), 
    .a(a), 
    .di(INIT_DATA), 
    .do(DOUT)     );
endmodule